---
title: 'XRSystem: requestSession()'
slug: Web/API/XRSystem/requestSession
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Method
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - XRSystem
  - requestSession
---
<div>{{APIRef("WebXR Device API")}}</div>

<p class="summary">The <strong>{{domxref("XRSystem")}}</strong> interface's <code><strong>requestSession()</strong></code> method returns a {{jsxref("promise")}} which resolves to an {{domxref("XRSession")}} object through which you can manage the requested type of WebXR session.</p>

<p class="summary">While only one immersive VR session can be active at a time, multiple inline sessions can be in progress at once.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var<em> sessionPromise = xr</em>.requestSession(<em>sessionMode</em>, <em>sessionInit</em>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><span style="display: none;"> </span><code>sessionMode</code><span style="display: none;"> </span></dt>
 <dd>
 <p>A {{domxref("DOMString")}} whose value is one of those included in the {{domxref("XRSessionMode")}} <code>enum</code>. The supported modes are:</p>
 {{page("/en-US/docs/Web/API/XRSessionMode", "Values")}}</dd>
 <dt><code>sessionInit</code> {{optional_inline}}</dt>
 <dd>A {{domxref("XRSessionInit")}} object providing options to configure the new {{domxref("XRSession")}}. See {{anch("Specifying session options")}} for details on how to configure a WebXR session.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves with an {{domxref("XRSession")}} object if the device and user agent support the requested mode and features.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method doesn't throw true exceptions; instead, it rejects the returned promise, passing into it a {{domxref("DOMException")}} whose <code>name</code> is one of the following:</p>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>The requested session mode is <code>immersive-vr</code> but there is already an immersive VR session either currently active or in the process of being set up. There can only be one immersive VR session at a time.</dd>
 <dt><code>NotSupportedError</code></dt>
 <dd>There is no WebXR-compatible device available, or the device does not support the specified <code>sessionMode</code>; this can also be thrown if any of the <em>required</em> options are unsupported.</dd>
 <dt><code>SecurityError</code></dt>
 <dd>
 <p>Permission to enter the specified XR mode is denied. This can happen for a number of reasons, which are covered in more detail in {{SectionOnPage("/en-US/docs/Web/API/WebXR_Device_API", "Permissions and security")}}.</p>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_an_immersive_VR_session">Creating an immersive VR session</h3>

<p>The following example calls <code>requestSession()</code> requesting an <code>"immersive-vr"</code> session. If the {{jsxref("Promise")}} resolves, it sets up a session and initiates the animation loop.</p>

<pre class="brush: js notranslate">navigator.xr.requestSession("immersive-vr")
.then((xrSession) =&gt; {
  xrSession.addEventListener('end', onXRSessionEnded);
  // Do necessary session setup here.
  // Begin the session’s animation loop.
  xrSession.requestAnimationFrame(onXRAnimationFrame);
}).catch(function(error) {
  // "immersive-vr" sessions are not supported
  console.warn("'immersive-vr' isn't supported, or an error occurred activating VR!");
});</pre>

<h3 id="Verifying_WebXR_support_and_using_a_button_to_start_VR_mode">Verifying WebXR support and using a button to start VR mode</h3>

<p>The following example shows how to use both <code>isSessionSupported()</code> and <code>requestSession()</code>. First, it checks to see if WebXR is available by verifying the existence of {{domxref("navigator.xr")}}. Next, it calls <code>isSessionSupported()</code>, passing it the desired session option before enabling controls for entering XR. Adding controls is a necessary step because entering XR requires a user action. Finally, the <code>onButtonClicked()</code> method calls <code>requestSession()</code> using the same session option passed to <code>isSessionSupported()</code>.</p>

<pre class="brush: js notranslate">if (navigator.xr) {
  navigator.xr.isSessionSupported('immersive-vr')
  .then((isSupported) =&gt; {
    if (isSupported) {
      immersiveButton.addEventListener('click', onButtonClicked);
      immersiveButton.textContent = 'Enter XR';
      immersiveButton.disabled = false;
    } else {
      console.log("WebXR doesn't support immersive-vr mode!");
    }
  });
} else {
  console.log("WebXR is not available!");
}

function onButtonClicked() {
  if (!xrSession) {
    navigator.xr.requestSession('immersive-vr')
    .then((session) =&gt; {
      xrSession = session;
      // onSessionStarted() not shown for reasons of brevity and clarity.
      onSessionStarted(xrSession);
    });
  } else {
    // Button is a toggle button.
    xrSession.end().then(() =&gt; xrSession = null);
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsystem-requestsession","requestSession()")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSystem.requestSession")}}</div>
